<?php

declare(strict_types=1);

namespace Dedi\SyliusEcotaxPlugin\DataFixtures\Fixtures;

use Doctrine\Persistence\ObjectManager;
use Sylius\Bundle\CoreBundle\Fixture\Factory\ExampleFactoryInterface;
use Sylius\Bundle\FixturesBundle\Fixture\FixtureInterface;
use Symfony\Component\Config\Definition\Builder\ArrayNodeDefinition;
use Symfony\Component\Config\Definition\Builder\TreeBuilder;

class EcotaxTypeFixture implements FixtureInterface
{
    public function __construct(
        private ObjectManager $objectManager,
        private ExampleFactoryInterface $ecotaxTypeFactory,
    ) {
    }

    public function getName(): string
    {
        return 'ecotax_type';
    }

    public function getConfigTreeBuilder(): TreeBuilder
    {
        $treeBuilder = new TreeBuilder($this->getName());

        /** @var ArrayNodeDefinition $optionsNode */
        $optionsNode = $treeBuilder->getRootNode();

        // @phpstan-ignore-next-line
        $optionsNode
            ->children()
            ->scalarNode('code')->defaultNull()->end()
            ->scalarNode('label')->defaultNull()->end()
        ;

        return $treeBuilder;
    }

    public function load(array $options): void
    {
        $block = $this->ecotaxTypeFactory->create($options);

        $this->objectManager->persist($block);
        $this->objectManager->flush();
    }
}
