<?php

declare(strict_types=1);

namespace Dedi\SyliusEcotaxPlugin\Form\Type;

use Dedi\SyliusEcotaxPlugin\Entity\EcotaxType as EcotaxTypeEntity;
use Sylius\Bundle\MoneyBundle\Form\Type\MoneyType;
use Sylius\Bundle\ResourceBundle\Form\Type\AbstractResourceType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints\NotBlank;
use Symfony\Component\Validator\Constraints\NotNull;

class EcotaxType extends AbstractResourceType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('type', EntityType::class, [
                'label' => 'sylius.ui.type',
                'class' => EcotaxTypeEntity::class,
                'constraints' => [
                    new NotBlank(),
                ],
            ])
            ->add('value', MoneyType::class, [
                'label' => 'sylius.ui.amount',
                'constraints' => [
                    new NotNull(),
                ],
            ]);
    }

    public function getBlockPrefix(): string
    {
        return 'ecotax';
    }
}
