<?php

declare(strict_types=1);

namespace Dedi\SyliusEcotaxPlugin\Model;

use Dedi\SyliusEcotaxPlugin\Entity\EcotaxInterface;
use Doctrine\Common\Collections\Collection;

interface EcotaxesAwareInterface
{
    /** @return Collection<int, EcotaxInterface> */
    public function getEcotaxes(): Collection;

    public function getEcotaxByCode(string $code): ?EcotaxInterface;

    public function addEcotax(EcotaxInterface $ecotax): static;

    public function hasEcotax(EcotaxInterface $ecotax): bool;

    public function removeEcotax(EcotaxInterface $ecotax): static;

    public function removeEcotaxes(): static;

    public function getTotalEcotaxes(): int;
}
